//
//  ATMPPR_Base.h
//  CanonCamera
//
//  Created by admin on 11/24/09.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
//#import <CoreFoundation/CoreFoundation.h>
//#import <unistd.h>
#import <sys/stat.h>
#import <sys/sysctl.h>
#import <mach/mach.h>

//#ifndef db
// #define  db(format, ...)    NSLog(@ format, ## __VA_ARGS__ )
//#endif
//
//#define DESTROY_CFTypeRef(arg)      (void *)((NULL == (arg)) ? NULL : (CFRelease(arg), (arg)=NULL))
//#define NULLIFY_REF_OF_POINTER(arg) (void *)((NULL != (arg) && NULL != *(arg)) ? (*(arg)=NULL) : NULL)





@interface ATMPPR_Base : NSObject {

}

+(id)firstFoundDirectoryType:(NSSearchPathDirectory)directoryType inDomain:(NSSearchPathDomainMask)domain;
+(NSString *)systemVersionInfo;
+(NSString *)startupInfo;
+(NSString *)safeTempFile:(int *)fileDescriptor;


@end
//@interface ATMPPR_Window : NSWindow {
//    
//}
//@end

@interface  NSWindow (ATMPPR_NSWindowAdditions)
-(void)fadeAway;
-(BOOL)windowShouldCancelFadeAway:(id)sender;
@end
@interface NSString (ATMPPR_NSStringAdditions)
-(NSComparisonResult)numericalCaseInsensitiveCompare:(NSString *)string;
+(id)stringWithCString:(const char *)bytes maxLength:(unsigned long)maxLength encoding:(NSStringEncoding)encoding;
-(id)stringByDeletingCharactersInSet:(NSCharacterSet *)undesired;
-(id)stringByReplacingSubStrings:(NSArray *)keys withValues:(NSArray *)values options:(NSStringCompareOptions)options range:(NSRange)range;
@end
@interface  NSDate (ATMPPR_NSDateAdditions)
// example: [[NSDate date] stringWithUTSFormat:@"[YYYY/MM/dd HH:mm:ss.SSS Z]"];
// for format string specifier symbols see: http://unicode.org/reports/tr35/
-(NSString *)stringWithUTSFormat:(NSString *)format;
@end
//@interface CIFilter (ATMPPR_CIFilterAdditions)
//-(NSString *)shortDescription;
//@end
@interface NSObject (ATMPPR_NSObjectAdditions)
+(id)pathToSelf;
@end
